import java.net.Socket;
import java.io.PrintWriter;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;

/**
 * Client
 * 
 * @author Taylor Born
 * @version January 2014
 */
public abstract class Client
{
    private Socket socket;
    private PrintWriter out;
    private BufferedReader in;

    public Client(Socket socket)
    {
        this.socket = socket;
        try {
            out = new PrintWriter(socket.getOutputStream(), true);
            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        } catch (IOException e) {}
//         socket.setPerformancePreferences(_connectionTime_, _latency_, _bandwidth_)
    }
    public Client(String ip, int port) throws IOException
    {
        this(new Socket(ip, port));
    }
    
    public synchronized void printLine(String line)
    {
        out.println(line);
    }
    
    public synchronized String readLine()
    {
        String line;
        try {
            if (!in.ready())
                return null;
            line = in.readLine();
        }
        catch (IOException e) {
            return null;
        }
        return line;
    }
    
    @Override
    public void finalize() throws Throwable
    {
        super.finalize();
        out.close();
        in.close();
        socket.close();
    }
}