import java.io.IOException;

/**
 * GameServer
 * 
 * @author Taylor Born
 * @version January 2014
 */
public class GameServer extends Server
{
    private int gameObjectCount = 0;

    public GameServer(int port) throws IOException
    {
        super(port);
    }
    
    @Override
    protected void act()
    {
        String propagateData = "";
        
        for (ClientInfoCopy client : clients) {
            String line = client.readLine();
            if (line != null) {
                
                String dataToPropagateByPlayer = "";
                while (!line.isEmpty()) {
                    int semicolonIndex = line.indexOf(';');
                    int colonIndex, x, y;
                    switch (line.charAt(0)) {
                        case 'L':
                            colonIndex = line.indexOf(':');
                            x = Integer.parseInt(line.substring(1, colonIndex));
                            y = Integer.parseInt(line.substring(colonIndex + 1, semicolonIndex));
                            client.setLocation(x, y);
                            dataToPropagateByPlayer += "L" + x + ":" + y + ";";
                            break;
                        case 'O':
                            colonIndex = line.indexOf(':');
                            x = Integer.parseInt(line.substring(1, colonIndex));
                            y = Integer.parseInt(line.substring(colonIndex + 1, semicolonIndex));
                            int gameObjectID = gameObjectCount++;
                            client.printLine("o" + gameObjectID + ";");
                            dataToPropagateByPlayer += "O" + gameObjectID + ":C" + x + ":" + y + ";";
                            break;
                        
                    }
                    line = line.substring(semicolonIndex + 1);
                }
                if (!dataToPropagateByPlayer.isEmpty())
                    propagateData += "P" + client.getIdentity() + ";" + dataToPropagateByPlayer;
            }
        }
        
        if (!propagateData.isEmpty())
            for (ClientInfoCopy client : clients) {
                client.printLine(propagateData);
            }
    }
    
    @Override
    protected void newClientAdded(ClientInfoCopy client)
    {
        int x = Screen.main.getPlayerStartX();
        int y = Screen.main.getPlayerStartY();
        client.setLocation(x, y);
        
        String propagateData = "P" + client.getIdentity() + ";" + "L" + x + ":" + y + ";";
        String dataForNewClient = "";
        
        for (ClientInfoCopy c : clients)
            if (c != client)
            {
                c.printLine(propagateData);
                dataForNewClient += "P" + c.getIdentity() + ";" + "L" + c.getX() + ":" + c.getY() + ";";
            }
        if (!dataForNewClient.isEmpty())
            client.printLine(dataForNewClient);
    }
}