import greenfoot.Actor;
import greenfoot.Greenfoot;

/**
 * PlayerShip
 * 
 * @author Taylor Born
 * @version January 2014
 */
public class PlayerShip extends Actor
{
    private static final int FIRING_DELAY = 100;

    private long timeOfLastShot = System.currentTimeMillis();
    private boolean mine;

    public PlayerShip(boolean mine)
    {
        this.mine = mine;
    }
    
    @Override
    public void act()
    {
        if (!mine)
            return;
        
        if (Greenfoot.isKeyDown("space"))
        {
            long currentTime = System.currentTimeMillis();
            if (currentTime - timeOfLastShot >= FIRING_DELAY)
            {
                Missile missile = new Missile();
                getWorld().addObject(missile, getX(), getY() - getImage().getWidth() / 2);
                Screen.main.shootMissile(missile);
                timeOfLastShot = currentTime;
            }
        }
        
        if (Greenfoot.isKeyDown("left") && getX() - getImage().getWidth() / 2 > 0)
            setLocation(getX() - 3, getY());
        if (Greenfoot.isKeyDown("right") && getX() + getImage().getWidth() / 2 < getWorld().getWidth())
            setLocation(getX() + 3, getY());
        
        if (Greenfoot.isKeyDown("up") && getY() - getImage().getHeight() / 2 > getWorld().getHeight() / 3)
            setLocation(getX(), getY() - 3);
        if (Greenfoot.isKeyDown("down") && getY() + getImage().getHeight() / 2 < getWorld().getHeight())
            setLocation(getX(), getY() + 3);
        
    }
    
    @Override
    public void setLocation(int x, int y)
    {
        super.setLocation(x, y);
        moved = true;
    }
    
    private boolean moved;
    public boolean hasMoved()
    {
        if (!moved)
            return false;
        moved = false;
        return true;
    }
}